local Arrow = Class("arrow")
local Vector = require("libs.vector")

function Arrow:initialize(x, y, width, height)
  self.body = love.physics.newBody(pWorld, x, y, "dynamic")
  self.shape = love.physics.newPolygonShape(0, 0, -width*.3, -height, -width, -height*.35, -width, height*.35, -width*.3, height)
  self.fixture = love.physics.newFixture(self.body, self.shape)
  self.body:setBullet(true)
  self.width = width
  self.height = height
end

function Arrow:update(dt)
  local px, py = self.body:getPosition()
  if py>1000 then
    self.body:destroy()
    Updater:remove("bow", self.__updaterkey)
  end
end

function Arrow:draw()
  local bx, by = self.body:getPosition()
  love.graphics.circle("fill", bx, by, 1)
end

return Arrow