--[[
  Description: Just a simple library that stores objects (of any kind) and execute the callbacks they have. It's not complete.
]]

local Updater = Class('Updater')

function Updater:initialize()
  self.lists = {}
  self.isUpdater = true
end


--If keep is true then the list won't be removed when easyRemoveAll is executed
function Updater:addList(name, keep)
  assert(name and type(name) == "string", "Argument is not valid. Type: " .. type(name) .. "; Data: " .. tostring(name))
  keep = keep or false
  self.lists[name] = {data = {__listkeep = keep, __name = name}}
  return name
end

function Updater:add(list, obj, tags)
  assert(self.lists[list], "You need to provide a valid list name")
  local key = #self.lists[list] + 1
  obj.__updaterkey = key
  self.lists[list][key] = obj
  return obj, key
end

function Updater:remove(list, key)
  self.lists[list][key] = nil
end

--Removes the list entirely
function Updater:removeList(list)
  self.lists[list] = nil
end

--Only removes the lists that weren't marked as "keep"
function Updater:easyRemoveAll()
  for key, list in pairs(self.lists) do
    if not list.data.__listkeep then
      self.lists[list.data.__name] = nil
    end
  end
end

--Clears the list but it will still exist
function Updater:clearList(list)
  self.lists[list] = {}
end

--Hook with entity tag system; Executes a function for every object that has a tag inside a list
function Updater:listExecuteWithTag(list, tag, f)
  for key, obj in pairs(self.lists[list]) do
    if obj:__checkTag(tag) then
      f(obj, list, key)
    end
  end
end

function Updater:pass(fname, ...)
  for k, list in pairs(self.lists) do
    for k2, obj in pairs(list) do
      if obj[fname] then
        obj[fname](obj, ...)
      end
    end
  end
end

function Updater:update(dt)
  self:pass("update", dt)
end
function Updater:draw()
  self:pass("draw")
end
function Updater:mousepressed(...)
  self:pass("mousepressed", ...)
end
function Updater:mousereleased(...)
  self:pass("mousereleased", ...)
end
function Updater:mousemoved(...)
  self:pass("mousemoved", ...)
end
function Updater:wheelmoved(...)
  self:pass("wheelmoved", ...)
end
function Updater:keypressed(...)
  self:pass("keypressed", ...)
end
function Updater:keyreleased(...)
  self:pass("keyreleased", ...)
end

return Updater